-------------------------------------------------------------------------------
-- Component Definitions
-------------------------------------------------------------------------------

-- Component: REGISTER ---------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity regis16 is
    port( rst, clk, load: in std_logic;
	  input: in std_logic_vector( 15  downto 0 );
	  output: out std_logic_vector( 15 downto 0 )
    );
end regis16;

architecture regis16_arc of regis16 is
begin
    process( rst, clk, load, input )
    begin
	if( rst = '1' ) then 
	    output <= "0000000000000000";
	elsif( clk'event and clk = '1') then
	    if( load = '1' ) then	
	        output <= input;
	    end if;
        end if;
    end process;
end regis16_arc;

-- Component: REGISTER ---------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity regis32 is
    port( rst, clk, load: in std_logic;
	  input: in std_logic_vector( 31  downto 0 );
	  output: out std_logic_vector( 31 downto 0 )
    );
end regis32;

architecture regis32_arc of regis32 is
begin
    process( rst, clk, load, input )
    begin
	if( rst = '1' ) then 
	    output <= "00000000000000000000000000000000";
	elsif( clk'event and clk = '1') then
	    if( load = '1' ) then
	        output <= input;
	    end if;
        end if;
    end process;
end regis32_arc;

------------- 16 to one multiplexer--------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity mux_16_1 is port(
  i0, i1, i2, i3, i4, i5, i6, i7 : in std_logic_vector(15 downto 0);
  i8, i9, i10, i11, i12, i13, i14, i15: in std_logic_vector(15 downto 0);
  sels : in std_logic_vector (3 downto 0);
  z : out std_logic_vector(15 downto 0));
end mux_16_1;

architecture usewith of mux_16_1 is
begin
  with sels select
    z <= i0 when "0000",
         i1 when "0001",
         i2 when "0010",
         i3 when "0011",
         i4 when "0100",
         i5 when "0101",
         i6 when "0110",
         i7 when "0111",
         i8 when "1000",
         i9 when "1001",
         i10 when "1010",
         i11 when "1011",
         i12 when "1100",
         i13 when "1101",
         i14 when "1110",
         i15 when "1111",
         "XXXXXXXXXXXXXXXX" when others;
end usewith;


------------- 16 to one demultiplexer----------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity demux_1_16 is port(
  sels : in std_logic_vector(4 downto 0);
  output: out std_logic_vector (16 downto 0));
end demux_1_16;
architecture imp of demux_1_16 is

begin

  with sels select
  output <= "00000000000000010" when "10000",
            "00000000000000100" when "10001",
            "00000000000001000" when "10010",
            "00000000000010000" when "10011",
            "00000000000100000" when "10100",
            "00000000001000000" when "10101",
            "00000000010000000" when "10110",
            "00000000100000000" when "10111",
            "00000001000000000" when "11000",
            "00000010000000000" when "11001",
            "00000100000000000" when "11010",
            "00001000000000000" when "11011",
            "00010000000000000" when "11100",
            "00100000000000000" when "11101",
            "01000000000000000" when "11110",
            "10000000000000000" when "11111",
            "00000000000000000" when others;
end imp;
